/*
 * JCudpp - Java bindings for CUDPP, the CUDA Data Parallel
 * Primitives Library, to be used with JCuda
 *
 * Copyright (c) 2009-2015 Marco Hutter - http://www.jcuda.org
 *
 * Permission is hereby granted, free of charge, to any person
 * obtaining a copy of this software and associated documentation
 * files (the "Software"), to deal in the Software without
 * restriction, including without limitation the rights to use,
 * copy, modify, merge, publish, distribute, sublicense, and/or sell
 * copies of the Software, and to permit persons to whom the
 * Software is furnished to do so, subject to the following
 * conditions:
 *
 * The above copyright notice and this permission notice shall be
 * included in all copies or substantial portions of the Software.
 *
 * THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
 * EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
 * OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
 * NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
 * HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
 * WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
 * FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
 * OTHER DEALINGS IN THE SOFTWARE.
 */

/* DO NOT EDIT THIS FILE - it is machine generated */
#include <jni.h>
/* Header for class jcuda_jcudpp_JCudpp */

#ifndef _Included_jcuda_jcudpp_JCudpp
#define _Included_jcuda_jcudpp_JCudpp
#ifdef __cplusplus
extern "C" {
#endif
#undef jcuda_jcudpp_JCudpp_CUDPP_HASH_KEY_NOT_FOUND
#define jcuda_jcudpp_JCudpp_CUDPP_HASH_KEY_NOT_FOUND -1L
/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    setLogLevel
 * Signature: (I)V
 */
JNIEXPORT void JNICALL Java_jcuda_jcudpp_JCudpp_setLogLevel
  (JNIEnv *, jclass, jint);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppCreateNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppCreateNative
  (JNIEnv *, jclass, jobject);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppDestroyNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppDestroyNative
  (JNIEnv *, jclass, jobject);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppPlanNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/jcudpp/CUDPPHandle;Ljcuda/jcudpp/CUDPPConfiguration;JJJ)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppPlanNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jlong, jlong, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppDestroyPlanNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppDestroyPlanNative
  (JNIEnv *, jclass, jobject);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppScanNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;J)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppScanNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppMultiScanNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;JJ)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppMultiScanNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jlong, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppSegmentedScanNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;J)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppSegmentedScanNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jobject, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppCompactNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;J)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppCompactNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jobject, jobject, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppReduceNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;J)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppReduceNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppRadixSortNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;J)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppRadixSortNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppMergeSortNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;J)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppMergeSortNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppStringSortNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;BJJ)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppStringSortNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jbyte, jlong, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppSparseMatrixNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/jcudpp/CUDPPHandle;Ljcuda/jcudpp/CUDPPConfiguration;JJLjcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppSparseMatrixNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jlong, jlong, jobject, jobject, jobject);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppDestroySparseMatrixNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppDestroySparseMatrixNative
  (JNIEnv *, jclass, jobject);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppSparseMatrixVectorMultiplyNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppSparseMatrixVectorMultiplyNative
  (JNIEnv *, jclass, jobject, jobject, jobject);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppRandNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;J)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppRandNative
  (JNIEnv *, jclass, jobject, jobject, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppRandSeedNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;I)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppRandSeedNative
  (JNIEnv *, jclass, jobject, jint);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppTridiagonalNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;II)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppTridiagonalNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jobject, jobject, jobject, jint, jint);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppCompressNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;J)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppCompressNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jobject, jobject, jobject, jobject, jobject, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppBurrowsWheelerTransformNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;J)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppBurrowsWheelerTransformNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jobject, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppMoveToFrontTransformNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;J)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppMoveToFrontTransformNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppListRankNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;Ljcuda/Pointer;JJ)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppListRankNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jobject, jlong, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppSuffixArrayNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;J)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppSuffixArrayNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppHashTableNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/jcudpp/CUDPPHandle;Ljcuda/jcudpp/CUDPPHashTableConfig;)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppHashTableNative
  (JNIEnv *, jclass, jobject, jobject, jobject);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppDestroyHashTableNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/jcudpp/CUDPPHandle;)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppDestroyHashTableNative
  (JNIEnv *, jclass, jobject, jobject);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppHashInsertNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;J)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppHashInsertNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppHashRetrieveNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;Ljcuda/Pointer;J)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppHashRetrieveNative
  (JNIEnv *, jclass, jobject, jobject, jobject, jlong);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppMultivalueHashGetValuesSizeNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;[I)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppMultivalueHashGetValuesSizeNative
  (JNIEnv *, jclass, jobject, jintArray);

/*
 * Class:     jcuda_jcudpp_JCudpp
 * Method:    cudppMultivalueHashGetAllValuesNative
 * Signature: (Ljcuda/jcudpp/CUDPPHandle;Ljcuda/Pointer;)I
 */
JNIEXPORT jint JNICALL Java_jcuda_jcudpp_JCudpp_cudppMultivalueHashGetAllValuesNative
  (JNIEnv *, jclass, jobject, jobject);

#ifdef __cplusplus
}
#endif
#endif
